package org.jboss.seam.example.booking;

import java.util.*;

import javax.ejb.*;
import javax.persistence.*;

import org.jboss.seam.annotations.*;
import org.jboss.seam.annotations.datamodel.*;
import org.jboss.seam.log.Log;

@Stateless
@Name("newHotel")
public class NewHotelAction
    implements NewHotel
{
    @PersistenceContext
    private EntityManager em;
  
    @In(create=true)
    private Hotel hotel;

    @Logger
    private Log log;

    public String saveHotel()
    {
        log.info("Saving hotel #{hotel}");
        em.persist(hotel);
        log.info("Created hotel id #{hotel.id}");
        return "/newHotelCreated.xhtml";
    }
}
