//$Id: DataModelSelection.java,v 1.4 2006/05/22 03:48:39 gavin Exp $
package org.jboss.seam.annotations.datamodel;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import org.jboss.seam.annotations.DataSelectorClass;
import org.jboss.seam.databinding.DataModelSelector;

/**
 * Injects the selected row data of a ListDataModel. Intended
 * for use with @DataModel.
 * 
 * @author Gavin King
 */
@Target({FIELD, METHOD})
@Retention(RUNTIME)
@Documented
@DataSelectorClass(DataModelSelector.class)
public @interface DataModelSelection
{
   /**
    * The context variable name of the DataModel. Defaults 
    * to the name for the outjected @DataModel if there
    * is exactly one @DataModel for the component.
    */
   String value() default "";
}
