package org.jboss.seam.core;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.annotations.Unwrap;
import org.jbpm.taskmgmt.exe.TaskInstance;

/**
 * Support for the pooled task list.
 * 
 * @see TaskInstanceList
 * @author Gavin King
 */
@Name( "pooledTaskInstanceList" )
@Scope( ScopeType.APPLICATION )
public class PooledTaskInstanceList
{
   
   @Unwrap
   @Transactional
   public List<TaskInstance> getPooledTaskInstanceList()
   {
      List<TaskInstance> pooledTaskInstanceList = new ArrayList<TaskInstance>();
      Set<String> actorIds = Actor.instance().getGroupActorIds();
      for (String actorId: actorIds )
      {
         pooledTaskInstanceList.addAll( ManagedJbpmContext.instance().getTaskMgmtSession().findPooledTaskInstances(actorId) );
      }
      return pooledTaskInstanceList;
   }
   
}
